SystemOrganization addCategory: #CopyHierarchy!

Object subclass: #CopyHierarchy
	instanceVariableNames: 'classNamePrefix classCategoryForDupedClass renameMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CopyHierarchy'!

!CopyHierarchy classSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/20/2012 12:20'!
classCategoryForExamples

	^'CopyHierarchyExampleResult'! !

!CopyHierarchy classSide methodsFor: 'example' stamp: 'hjo 7/20/2012 12:23'!
copySubclassesOfCollection

	^self new 
		classCategoryForDupedClass: (self classCategoryForExamples);
		classNamePrefix: 'X10';
		runWithSubclasses: Collection.! !

!CopyHierarchy classSide methodsFor: 'example' stamp: 'hjo 7/20/2012 12:24'!
copySubclassesOfGradientFillStyle

	^self new 
		classCategoryForDupedClass: (self classCategoryForExamples);
		classNamePrefix: 'X20';
		runWithSubclasses: GradientFillStyle.! !

!CopyHierarchy classSide methodsFor: 'example' stamp: 'hjo 7/20/2012 12:24'!
copySubclassesOfLineSegment

	^self new 
		classCategoryForDupedClass: (self classCategoryForExamples);
		classNamePrefix: 'X30';
		runWithSubclasses: LineSegment.! !

!CopyHierarchy classSide methodsFor: 'example' stamp: 'hjo 7/20/2012 12:18'!
copySuperclassesOfArray

	^self new 
		classCategoryForDupedClass: (self classCategoryForExamples);
		classNamePrefix: 'X40';
		runWithSuperclasses: Array.! !

!CopyHierarchy classSide methodsFor: 'example' stamp: 'hjo 7/20/2012 12:18'!
copySuperclassesOfCollection

	^self new 
		classCategoryForDupedClass: (self classCategoryForExamples);
		classNamePrefix: 'X50';
		runWithSuperclasses: Collection.! !

!CopyHierarchy classSide methodsFor: 'example' stamp: 'hjo 7/20/2012 12:18'!
copySuperclassesOfNil

	"This is invalid request. Should not do anything."
	^self new 
		classCategoryForDupedClass: (self classCategoryForExamples);
		classNamePrefix: 'X60';
		runWithSuperclasses: nil.! !

!CopyHierarchy classSide methodsFor: 'example' stamp: 'hjo 7/20/2012 12:19'!
copySuperclassesOfObject

	^self new 
		classCategoryForDupedClass: (self classCategoryForExamples);
		classNamePrefix: 'X70';
		runWithSuperclasses: Object.! !

!CopyHierarchy classSide methodsFor: 'example' stamp: 'hjo 7/20/2012 12:19'!
copySuperclassesOfProtoObject

	"This is invalid request. Should not do anything."
	^self new 
		classCategoryForDupedClass: (self classCategoryForExamples);
		classNamePrefix: 'x80';
		runWithSuperclasses: ProtoObject.! !

!CopyHierarchy classSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/20/2012 12:08'!
runAllExample

	(self class methodsInCategory: 'example') do: [:sel|
		self perform: sel ].! !

!CopyHierarchy methodsFor: 'private' stamp: 'HwaJong 12/4/2012 11:47'!
changeSuperclassAfterDupClass: aClass

	|dup|
	dup := self dupClass: aClass.
	dup superclass name = (self nameOfDupOfClass: aClass superclass) ifTrue: [^self].
	(Smalltalk classNamed: dup name) moveToSuperclassNamed: (self nameOfDupOfClass: aClass superclass).! !

!CopyHierarchy methodsFor: 'accessing' stamp: 'hjo 7/20/2012 11:09'!
classCategoryForDupedClass: aString 

	classCategoryForDupedClass := aString! !

!CopyHierarchy methodsFor: 'testing' stamp: 'hjo 7/20/2012 11:09'!
classExistsByName: aSymbol

	^[Smalltalk at: aSymbol. true] on: KeyNotFound do: [:exp| false ].! !

!CopyHierarchy methodsFor: 'accessing' stamp: 'hjo 7/20/2012 11:09'!
classNamePrefix: aString 

	classNamePrefix := aString ! !

!CopyHierarchy methodsFor: 'private' stamp: 'HwaJong 12/11/2012 17:05'!
dupClass: aClass

	| dupName dup |
	dupName := self nameOfDupOfClass: aClass.
	(self classExistsByName: dupName) ifTrue: [ ^Smalltalk at: dupName ].
	dup := aClass duplicateClassWithNewName: dupName.
	renameMap at: aClass name put: dupName.
	dup category: classCategoryForDupedClass.
	^dup! !

!CopyHierarchy methodsFor: 'initialize-release' stamp: 'HwaJong 12/11/2012 17:02'!
initialize
super initialize.
renameMap := Dictionary new.! !

!CopyHierarchy methodsFor: 'accessing' stamp: 'hjo 7/20/2012 11:10'!
nameOfDupOfClass: aClass

	^(classNamePrefix, aClass name) asSymbol! !

!CopyHierarchy methodsFor: 'undo' stamp: 'hjo 7/20/2012 11:11'!
removeCategoryOfDupes

	self class environment organization removeSystemCategory: classCategoryForDupedClass.! !

!CopyHierarchy methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/11/2012 17:02'!
renameClassReferencesToCopied
	renameMap keys
		do: [ :oneClassName | 
			| newOneClassName oneClass replacer |
			newOneClassName := renameMap at: oneClassName.
			oneClass := Smalltalk classNamed: oneClassName.
			replacer := (RBParseTreeRewriter replaceLiteral: oneClassName with: newOneClassName)
				replace: oneClassName with: newOneClassName;
				replaceArgument: newOneClassName
					withValueFrom: [ :aNode | self refactoringError: newOneClassName , ' already exists within the reference scope' ];
				yourself.
			(renameMap values collect: [ :ea | Smalltalk classNamed: ea ])
				do: [ :eachNewClasses | 
					| methodsOfEachNewClassesThatRefersTheClass |
					methodsOfEachNewClassesThatRefersTheClass := eachNewClasses methods
						select: [ :m | m hasLiteralSuchThat: [ :ass | ass value = oneClass ] ].
					methodsOfEachNewClassesThatRefersTheClass
						do: [ :methodHavingOldClass | 
							| parseTree rewriteSucceeded |
							parseTree := methodHavingOldClass parseTree.
							rewriteSucceeded := replacer executeTree: parseTree.
							methodHavingOldClass methodClass
								compile: parseTree newSource
								classified: methodHavingOldClass category
								notifying: nil ] ] ]! !

!CopyHierarchy methodsFor: 'public operation' stamp: 'hjo 7/20/2012 11:16'!
runWithSubclasses: aClass

	self dupClass: aClass.
	aClass allSubclassesDo: [:each| self changeSuperclassAfterDupClass: each ].! !

!CopyHierarchy methodsFor: 'public operation' stamp: 'hjo 7/20/2012 11:27'!
runWithSuperclasses: aClass

	aClass = nil ifTrue: [^self].
	aClass superclass = nil ifTrue: [ ^self "^self dupClass: aClass" ].
	self runWithSuperclasses: (aClass superclass).
	self changeSuperclassAfterDupClass: aClass.! !
